import java.awt.*;

class inpWin extends Frame{
//Window for INTEGER input
boolean fin=false;
boolean minusFlg; int charCount;

//visual components
Label tit,err;  TextField inp;  Button ok;

//constructor
inpWin() {
//create window
super("Window for input ");

setLayout(null); setBackground(Color.white);

//create visual components
tit = new Label("Please input integer value"); add(tit); tit.reshape(20,30,200,20);
inp = new TextField(); add(inp); inp.reshape(75,60,50,20);
err = new Label(); add(err); err.reshape(20,90,200,20);
ok = new Button("OK"); add(ok); ok.reshape(75,120,50,20);
} //end constructor

boolean chkNum() {
String s=inp.getText();
if (s.equals("-")) inp.setText("0");
int i=Integer.parseInt(s);
boolean r=Math.abs(i)<32768;
if (r) err.setText(""); else err.setText("Overflow!");
return r;
}

public boolean action(Event evtObj, Object arg) {
if (evtObj.target instanceof Button)
   {if (arg.equals(ok.getLabel())) //OK button
        {if (chkNum()) {fin=true; hide();}
         return true;
         }
   }
return false;
}

//keyboard control
public boolean keyDown(Event e, int key) {
boolean r;
char kb=(char) key; 
minusFlg=(charCount != 0); //- can be only the first char
r=((kb>='0') & (kb<='9')) | ((kb=='-') & (!minusFlg)) | (key==8);
if (r & (key!=8)) charCount++; if ((key==8) & (charCount>0)) charCount--;
if (r) {minusFlg=true; err.setText("");} else err.setText("incorrect symbol - ignored");
return (!r);
}

//delete window
public boolean handleEvent(Event e) {
if (e.id==Event.WINDOW_DESTROY) {
   if (inp.getText().length()==0) inp.setText("0");
   fin=true; hide(); return true;}
return super.handleEvent(e);
}

}

class inpWin2 extends Frame{
//Window for BOOLEAN input
boolean fin=false;

//visual components
Label tit; Choice v; Button ok;

//constructor
inpWin2() {
//create window
super("Window for input ");

setLayout(null); setBackground(Color.white);

//create visual components
tit = new Label("Please select boolean value"); add(tit); tit.reshape(20,30,200,20);
v = new Choice(); add(v); v.reshape(75,70,50,20); v.addItem("false"); v.addItem("true");
ok = new Button("OK"); add(ok); ok.reshape(75,120,50,20);
} //end constructor

public boolean action(Event evtObj, Object arg) {
if (evtObj.target instanceof Button)
   {if (arg.equals(ok.getLabel())) //OK button
        {fin=true; hide();
         return true;
         }
   }
return false;
}

//delete window
public boolean handleEvent(Event e) {
if (e.id==Event.WINDOW_DESTROY) {
   fin=true; hide(); return true;}
return super.handleEvent(e);
}

}
