import java.applet.*;
import java.awt.*;

public class ctrlmchn extends java.applet.Applet implements Runnable{

command1 e97 = new command1(); //create machine!!!

Thread exec=null;  //tread for execution E97 program
boolean threadFinished=false;

static Font myFont = new Font("Dialog",Font.PLAIN,12);
private boolean firstTime=true;

//  ##### Visual components #####
int editX=50; int editY=20; //size of edits
int butX=editX; int butY=editY; //size of buttons
int dx=20; //from text to edit
int leftX1=20; //1 col. (R0 - R3)
int leftX2=leftX1+dx+editX+leftX1;  //2 col. (PC, SP, Ri, PS)
int leftX3=leftX2+dx+editX+leftX1;  //3 col. (memory)
int memWid=120;
int leftX4=leftX3+memWid+leftX1;  //4 col. (memory control)
int dy=10; //between edits
int topY1=20; //top of edits
int topY2=topY1+150; //top of buttons

TextField edits[] = new TextField[10];

TextArea RAM = new TextArea("0000",e97.myMemorySize/2,10);

Button startB, stopB, contB, clsB, readB, writeB;

Checkbox viReg; //regs visualization
Checkbox viRAM; //RAM visualization
CheckboxGroup au_st; //auto - step
Checkbox au,st; //(in au_st group)
 
Label bitsNZ;
Label disp1;

TextArea display = new TextArea();

//  ##### Font for components #####
static void setMyFont(Component c) {
c.setFont(myFont);
}

//  ##### Work with display #####
void addSym(char c) {
String s = new String(); s=""+c;
if ( ((int) (c)) != 13 )
  {int l=display.getText().length();
  display.replaceText(s,l,l+1);
  } 
  else //to next line
  display.appendText(""+(char)10);
}

void addToDisp(String s) {
int i=0; 
while (i<s.length())
         { addSym(s.charAt(i)); i++; }
//display.appendText(s);
}

//  ##### Exchange with edits #####
void getValues() {
//Read values that user input
for (int i = 0;  i < 4;  i++) 
     e97.R[i] = (short) fromHexString(edits[i].getText());
e97.PC = (short) fromHexString(edits[4].getText());
e97.SP = (short) fromHexString(edits[5].getText());
e97.Ri =  (short) fromHexString(edits[6].getText());
e97.flags = (short) fromHexString(edits[7].getText());
}

void showRegValues() {
//Show current values
for (int i = 0;  i < 4;  i++) 
     edits[i].setText(short_To_Hex(e97.R[i]));
edits[4].setText(short_To_Hex(e97.PC));
edits[5].setText(short_To_Hex(e97.SP));
edits[6].setText(short_To_Hex(e97.Ri));
edits[7].setText(short_To_Hex(e97.PS));
int fn=0; int fz=0;
if (e97.flagN()) fn=1; if (e97.flagZ()) fz=1;
bitsNZ.setText("Z="+fz+"  N="+fn);
}

void showRAMValues() {
int charPerString=15;
short addr = fromHexString(edits[8].getText()); if (addr >0xFE) addr=0;
edits[9].setText(short_To_Hex(e97.eGetMem(addr)));
String newText="";
for (short a=0; a<e97.HiRAM; a += 2 )
     {int v=e97.eGetMem(a);
      char c1=(char)(v & 0xFF); char c2=(char)(v >>> 8);
      if (c1<' ') c1='.'; if (c2<' ') c2='.';
      newText += short_To_Hex(a)+" "+short_To_Hex(e97.eGetMem(a))+"   "+c1+c2+(char)10;
     }
RAM.setText(newText);
int s=charPerString*(addr/2);
RAM.select(s,s); //to the beginning
}

void setNewValue() {
short addr = fromHexString(edits[8].getText()); if (addr >0xFE) addr=0;
short newVal = fromHexString(edits[9].getText());
e97.eSetMem(addr,newVal);
if (addr<0xFE)
   edits[8].setText(short_To_Hex((short)(fromHexString(edits[8].getText())+2)));
showRAMValues();
}

//  ##### Hex #####
String leftNul(String s) {
//adds left 0 untill 4 numbers
int l=s.length();
int i=1;
while (i<=4-l) {s="0"+s; i++;}
return s;
}

short fromHexString(String st) {
//Converts hex-string into short; if error - returns 0
int rez,i,ds; char s; String e; boolean num, let;
st = leftNul(st);
rez=0; e=""; ds=(int)'a'- (int)'A';
for (i=0;  i<4; i++)
    {s=st.charAt(i);
    if ( (s>='a') & (s<='z') ) s=(char)((int)s-ds); //Shift:  'a' ==> 'A' ...
    num=(s>='0') & (s<='9'); let=(s>='A') & (s<='F');
    if (num | let)
       {rez=16*rez+(int)s;
        if (num) 
           rez=rez-(int)'0';
           else rez=rez+10-(int)'A';
        }
        else e="invalid symbol";
    } 
if (e.length()!=0) rez=0;
return (short)rez;
}

String short_To_Hex(short c) {
//Converts short into 4-num hex-String
int ic=0xFFFF&c; int k;
String  rez = new String("");
for (int i=1; i<5; i++)
     {k=ic%16; ic /= 16;
      if (k>9) 
         k=(int)'A'+(k-10);
         else k=(int)'0'+k;
       rez = (char)k+rez;
      }
return rez;
}

//  ##### Initialize the applet #####
public void init() {
setLayout(null); setBackground(Color.white);

for (int i1=0; i1<8; i1++)
    {edits[i1] = new TextField();
     add(edits[i1]); setMyFont(edits[i1]);
     edits[i1].reshape(leftX1+dx+i1/4*(editX+leftX1+dx),topY1+i1%4*(editY+dy),
                       editX,editY);
    }

bitsNZ = new Label("Z=0  N=0"); add(bitsNZ); bitsNZ.reshape(leftX2+10,topY1+4*(editY+dy)-14,70,editY);
setMyFont(bitsNZ);

edits[8] = new TextField("0000"); add(edits[8]); edits[8].reshape(leftX4,topY1,editX,editY);
setMyFont(edits[8]);
edits[9] = new TextField("0000"); add(edits[9]); edits[9].reshape(leftX4,topY1+2*(editY+dy),editX,editY);
setMyFont(edits[9]);
readB = new Button("read"); add(readB); readB.reshape(leftX4,topY1+editY+dy,butX, butY);
setMyFont(readB);
writeB = new Button("write"); add(writeB); writeB.reshape(leftX4,topY1+3*(editY+dy),butX, butY);
setMyFont(writeB);

int yy0=topY2-topY1-dy;
add(RAM); RAM.reshape(leftX3,topY1,memWid,yy0); RAM.setEditable(false);
setMyFont(RAM);

startB = new Button("start"); add(startB); startB.reshape(leftX1,topY2,butX, butY);
setMyFont(startB);

stopB = new Button("stop"); add(stopB); stopB.reshape(leftX1+butX+10,topY2,butX, butY);
setMyFont(stopB);

contB = new Button("cont"); add(contB); contB.reshape(leftX1+2*(butX+10),topY2,butX, butY);
setMyFont(contB);

clsB = new Button("cls"); add(clsB); clsB.reshape(leftX4+60,topY2,butX,butY);
setMyFont(clsB);

viReg = new Checkbox("regs visualization"); add(viReg); viReg.reshape(leftX1,topY1+ 4*(editY+dy),115, editY);
viReg.setState(true);
setMyFont(viReg);
viRAM = new Checkbox("RAM visualization"); add(viRAM); viRAM.reshape(leftX4,topY1+ 4*(editY+dy),115, editY);
setMyFont(viRAM);

au_st = new CheckboxGroup();
au = new Checkbox("auto",au_st,true); setMyFont(au);
st = new Checkbox("step",au_st,false); setMyFont(st);
add(au); add(st);
au.reshape(leftX3+10,topY2,50,editY); st.reshape(leftX3+70,topY2,50,editY);

disp1 = new Label(""); add(disp1); disp1.reshape(leftX4-25,topY2,100,editY);
setMyFont(disp1);

add(display);
display.reshape(leftX1,topY2+butY+5,430,100); display.setEditable(false); setMyFont(display);
addToDisp("(C) ESC: Evgeny Eremin (Russia), 1997-2000. Educational computer E97."+((char) 13));

//Get program from HTML page
String p=new String();  p=getParameter("prog"); p=p+" ";
String w=new String(); int i; int a=0;
while (p.length() != 0)
        {i=p.indexOf(" "); w=p.substring(0,i); p=p.substring(i+1);
         e97.myMem[a]=fromHexString(w); a++;
        }
//e97.myMem[0]=0x01D0; e97.myMem[1]=0x0041;
//e97.myMem[2]=(short)0x9C0D; e97.myMem[3]=0x4088;
//e97.myMem[4]=0x2210;e97.myMem[5]=0x04D0;
//e97.myMem[6]=(short)0x005A;e97.myMem[7]=0x6DF4;
//e97.myMem[8]=0x0F00;e97.myMem[9]=0x0F00;
showRegValues(); showRAMValues();

}


//Get Applet information
public String getAppletInfo() {
return "E.A.Eremin: E97 Applet";
}

void correctWidth(Graphics g) {
//calculate length of visual component captions
int zap=25;
g.setFont(myFont);
FontMetrics fm = g.getFontMetrics();
//labels
int ls = fm.stringWidth(bitsNZ.getText())+zap; bitsNZ.reshape(leftX2+10,topY1+4*(editY+dy)-14, ls, editY);
ls = fm.stringWidth("Running...")+zap; disp1.reshape(leftX4-25,topY2, ls, editY);
//choices
ls = fm.stringWidth(viReg.getLabel())+zap; viReg.reshape(leftX1,topY1+ 4*(editY+dy), ls, editY);
ls = fm.stringWidth(viRAM.getLabel())+zap; viRAM.reshape(leftX4,topY1+ 4*(editY+dy), ls, editY);
ls = fm.stringWidth(au.getLabel())+zap; au.reshape(leftX3+10,topY2, ls, editY);
ls = fm.stringWidth(st.getLabel())+zap; st.reshape(leftX3+70,topY2, ls, editY);
firstTime=false; //correction must be done only once;
}

public void paint(Graphics g){
Dimension d=size();  //applet window size
g.drawRect(0,0,d.width-1,d.height-1);
g.drawRect(1,1,d.width-3,d.height-3); //window border

if (firstTime) correctWidth(g);
g.setFont(new Font("Dialog",Font.BOLD,12));

int y0=topY1+15;
for (int i1=0; i1<4; i1++)
    g.drawString("R"+i1,leftX1,y0+i1*(editY+dy));
g.drawString("PC",leftX2,y0);
g.drawString("SP",leftX2,y0+editY+dy);
g.drawString("Ri",leftX2,y0+2*(editY+dy));
g.drawString("PS",leftX2,y0+3*(editY+dy));

g.drawString("address",leftX4+editX+5,y0);
g.drawString("value",leftX4+editX+5,y0+2*(editY+dy));

Color oldC=g.getColor(); g.setColor(Color.pink);
g.drawString("Processor",85,15); g.drawString("RAM",300,15);
g.drawLine(2,topY2-5,d.width-3,topY2-5); g.drawLine(leftX3-10,2,leftX3-10,topY2-5);
g.setColor(oldC);

showStatus(" Educational computer E97 ");

}

//Buttons
public boolean action(Event e, Object o) {
if (threadFinished) {exec.stop(); exec=null; } threadFinished=false; //delete exec thread
if (e97.inputFlg) return false; //ignore buttons while input
if (e.target instanceof Button)
   {String s = (String) o;  //button name
showStatus("Button "+s+" was pressed.");
    if (s.equals("start"))
       {getValues();
       e97.stop = false; e97.errmsg="";
//for start only!!!
       e97.PC=0; e97.SP=0x0100; e97.flags=0;
       e97.keyBuf=""; e97.kbdCount=0; e97.crtBuf=""; e97.crtCount=0;
       addToDisp("Program started"+(char)13);
       if (exec==null) {exec = new Thread(this); exec.start(); } //create tread
       return true;
       }

    if (s.equals("cont"))
       {getValues();
       e97.stop = false; e97.errmsg="";
       if (exec==null) {exec = new Thread(this); exec.start(); } //create tread
       return true;
       }

    if (s.equals("stop")) {e97.stop =true; return true;}

    if (s.equals("read")) {showRAMValues(); return true;}

    if (s.equals("write")) {setNewValue(); return true;}

    if (s.equals("cls")) {display.setText(""); return true;}
   }
return false;
}

//  ##### Tread: execution of E97 program #####
public void run(){  //the work of the thread
disp1.setText("Running...");
while ( (e97.errmsg.equals("")) & (!e97.stop) ) //no errors & not stop
        {e97.komanda();
         if (e97.crtBuf.length() != 0) 
           {addToDisp(e97.crtBuf); e97.crtBuf=""; }
         if (viReg.getState()) showRegValues();
         if (viRAM.getState()) showRAMValues();
         e97.stop |= st.getState(); //stop in "step" regim
         }
e97.stop =true; threadFinished=true; disp1.setText("");
if (e97.curPCb) 
  {addToDisp(""+(char)13+"while executing "+short_To_Hex(e97.curPC));
   if (e97.goodadr(e97.curPC)) 
      addToDisp(": "+short_To_Hex(e97.eGetMem(e97.curPC)));
  }
if (au.getState()) //don't print when step regime
   {addToDisp(""+(char)13+"End of program"+(char)13); showStatus("End of program");}
   else showStatus("Step is done");
showRegValues(); showRAMValues();
}

//public void start(){ 
//exec.resume(); //when return to page
//}

public void stop(){
//when leave page
if (exec != null) {e97.stop =true; exec.stop(); exec = null;
                         addToDisp(""+(char)13+"Program terminated"+(char)13); }
}

public void destroy(){
if (exec != null) {exec.stop(); exec = null;}  //when finish
}

//Keyboard
public boolean keyDown(Event e, int key) {
int buflen; char kb;
if (! e97.stop) //"E97" program is running
   {buflen=e97.keyBuf.length();
    kb=(char) key; 
    //if kb=chr(3) then doBreak;
    e97.keyBuf += kb;  buflen++;
    showStatus(e97.keyBuf);
    if (buflen>8) 
      {e97.keyBuf=e97.keyBuf.substring(0,8); e97.errmsg="keyboard buffer is full"; }
    return true; }
    else return false;
}

}
